// Nixie_Uhr.cpp
// --------- Version 22.03.2002, Udo Sobotta
// Borland IDE 3.1
// Model: SMALL
// char: unsigned
//-------------------------------------------
// Hardware: standalone SC12@Chip / Nixie Anzeige
// mit 2 PCF 8574 8 Bit Toradaptern
// Ausgabe von Datenbytes an beide Tore, die als
// Anzeige der DOS Uhr betrachtet werden koennen.

#pragma hdrstop
#include <dos.h>
#include <stdio.h>
#include <stdlib.h>
//---------------------------------------------------------------------------

#pragma argsused
#define i2cTOR0 0x74            // I2C Adresse von Tor #0
#define i2cTOR1 0x78            // I2C Adresse von Tor #1

int i=0,a=0,z=0,m=0,n=0; 		// einige Variable
unsigned int jahr;
unsigned char monat, tag, tagnr;
unsigned char stunde, minute;
unsigned char sekunde;
int udo=32;
unsigned char wotag;
static union REGS inregs;	// vorbereitung der Register
static union REGS outregs;	// fuer Interruptaufrufe

// API-Systemfunktionen
// --------------------
void sleep(unsigned time)
{
	inregs.h.ah = 0x09;
	inregs.x.bx = time;
	int86(0xAC,&inregs,&outregs);
}
// API - I2C- Funktionen
// ---------------------

void i2c_init(void)
{
	inregs.h.ah = 0x80;
	int86(0xAA,&inregs,&outregs);
}

void i2c_release(void)
{
	inregs.h.ah = 0x84;
	inregs.h.al = 0;
	int86(0xAA,&inregs,&outregs);
}

int i2c_transmit(char tor, char c)
{
	inregs.h.ah = 0x82;
	inregs.h.al = tor & 0xfe;
	inregs.h.cl = c;
	int86(0xAA,&inregs,&outregs);
	if(outregs.x.flags&0x01)
	{
		return (int)outregs.h.al & 0x00FF;
	}
	return 0;
}
void holedatum(void)
{
	inregs.h.ah = 0x2A;	        // SoftINT 21h, FKT. 2Ah
	int86(0x21, &inregs, &outregs);	// Aufruf der Interrupt Routine
	jahr   = outregs.x.cx;		// Jahr 4 stellig
	monat  = outregs.h.dh;		// Monat 1 - 12
	tag    = outregs.h.dl;		// Tag 1 - 31
	tagnr  = outregs.h.al;		// Wochentag, 0 = Sonntag
}
void holezeit(void)
{
	inregs.h.ah = 0x2C;		// SoftINT 21h, FKT. 2Ch
	int86(0x21, &inregs, &outregs);	// Aufruf der Interrupt Routine
	stunde = outregs.h.ch;		// Stunde 1 - 23
	minute = outregs.h.cl;		// Minuten 0 - 59
	sekunde= outregs.h.dh;		// Sekunde 0 - 59
}
void setdate(void)
	{
	 udo=tag/10;
	 i2c_transmit(i2cTOR1,tag%10+16*udo); // Schicke Tag an Tor 1
	 i2c_release();               // Bus freigeben
	 i2c_transmit(i2cTOR0,0x70);	// Schicke Wert 'i' an Tor 0
	 i2c_release();          	// Bus freigeben
	 i2c_transmit(i2cTOR0,0xff); 	// Schicke Wert '0xFF' an Tor 0
	 i2c_release();          	// Bus freigeben
	 udo=monat/10;
	 i2c_transmit(i2cTOR1,monat%10+16*udo); // Schicke Monat an Tor 1
	 i2c_release();               // Bus freigeben
	 i2c_transmit(i2cTOR0,0xb0);	// Schicke Wert 'i' an Tor 0
	 i2c_release();          	// Bus freigeben
	 i2c_transmit(i2cTOR0,0xff); 	// Schicke Wert '0xFF' an Tor 0
	 i2c_release();          	// Bus freigeben
	 udo=(jahr-2000)/10;
	 i2c_transmit(i2cTOR1,jahr%10+16*udo); // Schicke Jahr an Tor 1
	 i2c_release();               // Bus freigeben
	 i2c_transmit(i2cTOR0,0xe0);	// Schicke Wert 'i' an Tor 0
	 i2c_release();          	// Bus freigeben
	 i2c_transmit(i2cTOR0,0xff); 	// Schicke Wert '0xFF' an Tor 0
	 i2c_release();          	// Bus freigeben
	 sleep(10);
	}// ende Setdate

void settime(void)
	{
	   udo=sekunde/10;
	   i2c_transmit(i2cTOR1,sekunde%10+16*udo); // Schicke Sekundenwert an Tor 1
	   i2c_release();               // Bus freigeben
	   i2c_transmit(i2cTOR0,0xe0);	// Setze Tor 0 Sekundendigit
	   i2c_release();          	// Bus freigeben
	   i2c_transmit(i2cTOR0,0xff); 	// Schicke Wert '0xFF' an Tor 0
	   i2c_release();          	// Bus freigeben
	   udo=minute/10;
	   i2c_transmit(i2cTOR1,minute%10+16*udo);  // Schicke Minutenwert an Tor 1
	   i2c_release();               // Bus freigeben
	   i2c_transmit(i2cTOR0,0xb0);	// Setze Tor 0 Minutendigit
	   i2c_release();          	// Bus freigeben
	   i2c_transmit(i2cTOR0,0xff); 	// Schicke Wert '0xff' an Tor 0
	   i2c_release();          	// Bus freigeben
	   udo=stunde/10;
	   i2c_transmit(i2cTOR1,stunde%10+16*udo); // Schicke Stundenwert an Tor 1
	   i2c_release();               // Bus freigeben
	   i2c_transmit(i2cTOR0,0x70);	// Schicke Wert 'i' an Tor 0
	   i2c_release();          	// Bus freigeben
	   i2c_transmit(i2cTOR0,0xff); 	// Schicke Wert '0xFF' an Tor 0
	   i2c_release();		// Bus freigeben
	   sleep(10);
	 }// End Settime
void reset(void)  // Reset Anzeige und Ausgabe : gestartet
	{
	   printf("\r\n i2c-Nixie Udo initialisiert und gestartet\r\n");
	   i2c_init();                     // I2C Bus initialisieren
	   i2c_transmit(i2cTOR0,0x02); 	// RESET
	   i2c_release();
	} // Ende Reset


// Ende der API

// Hauptprogramm
// Ausgabe von Datenbytes an die I2C / Nixie Anzeige
// beide Tore #0 und #1

void main (void)			// Hauptprogramm
{
reset();
do
	{
	   holezeit();
	   holedatum();
	   m=sekunde;
	   n=jahr;
	   if(m!=n-2000 || m!=n-1970)
	   {
	   settime();
	   }
	   if(m==n-2000 || m==n-1970)
	   {
	   setdate();
	   sleep(1000);
	   //z++;
	   }
	}
	while (z<=5);

} // main
